/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the UserSubscriptionByLifecycleSettings type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &UserSubscriptionByLifecycleSettings{}

// UserSubscriptionByLifecycleSettings struct for UserSubscriptionByLifecycleSettings
type UserSubscriptionByLifecycleSettings struct {
	Application                               *ApplicationInfo                   `json:"application,omitempty"`
	LifecycleSettings                         *LifecycleSettingsInfo             `json:"lifecycleSettings,omitempty"`
	Status                                    *UserApplicationSubscriptionStatus `json:"status,omitempty"`
	IsAdmin                                   *bool                              `json:"isAdmin,omitempty"`
	JoinSelfSubscriptionGroupPendingRequestId NullableString                     `json:"joinSelfSubscriptionGroupPendingRequestId,omitempty"`
}

// NewUserSubscriptionByLifecycleSettings instantiates a new UserSubscriptionByLifecycleSettings object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewUserSubscriptionByLifecycleSettings() *UserSubscriptionByLifecycleSettings {
	this := UserSubscriptionByLifecycleSettings{}
	return &this
}

// NewUserSubscriptionByLifecycleSettingsWithDefaults instantiates a new UserSubscriptionByLifecycleSettings object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewUserSubscriptionByLifecycleSettingsWithDefaults() *UserSubscriptionByLifecycleSettings {
	this := UserSubscriptionByLifecycleSettings{}
	return &this
}

// GetApplication returns the Application field value if set, zero value otherwise.
func (o *UserSubscriptionByLifecycleSettings) GetApplication() ApplicationInfo {
	if o == nil || IsNil(o.Application) {
		var ret ApplicationInfo
		return ret
	}
	return *o.Application
}

// GetApplicationOk returns a tuple with the Application field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserSubscriptionByLifecycleSettings) GetApplicationOk() (*ApplicationInfo, bool) {
	if o == nil || IsNil(o.Application) {
		return nil, false
	}
	return o.Application, true
}

// HasApplication returns a boolean if a field has been set.
func (o *UserSubscriptionByLifecycleSettings) HasApplication() bool {
	if o != nil && !IsNil(o.Application) {
		return true
	}

	return false
}

// SetApplication gets a reference to the given ApplicationInfo and assigns it to the Application field.
func (o *UserSubscriptionByLifecycleSettings) SetApplication(v ApplicationInfo) {
	o.Application = &v
}

// GetLifecycleSettings returns the LifecycleSettings field value if set, zero value otherwise.
func (o *UserSubscriptionByLifecycleSettings) GetLifecycleSettings() LifecycleSettingsInfo {
	if o == nil || IsNil(o.LifecycleSettings) {
		var ret LifecycleSettingsInfo
		return ret
	}
	return *o.LifecycleSettings
}

// GetLifecycleSettingsOk returns a tuple with the LifecycleSettings field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserSubscriptionByLifecycleSettings) GetLifecycleSettingsOk() (*LifecycleSettingsInfo, bool) {
	if o == nil || IsNil(o.LifecycleSettings) {
		return nil, false
	}
	return o.LifecycleSettings, true
}

// HasLifecycleSettings returns a boolean if a field has been set.
func (o *UserSubscriptionByLifecycleSettings) HasLifecycleSettings() bool {
	if o != nil && !IsNil(o.LifecycleSettings) {
		return true
	}

	return false
}

// SetLifecycleSettings gets a reference to the given LifecycleSettingsInfo and assigns it to the LifecycleSettings field.
func (o *UserSubscriptionByLifecycleSettings) SetLifecycleSettings(v LifecycleSettingsInfo) {
	o.LifecycleSettings = &v
}

// GetStatus returns the Status field value if set, zero value otherwise.
func (o *UserSubscriptionByLifecycleSettings) GetStatus() UserApplicationSubscriptionStatus {
	if o == nil || IsNil(o.Status) {
		var ret UserApplicationSubscriptionStatus
		return ret
	}
	return *o.Status
}

// GetStatusOk returns a tuple with the Status field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserSubscriptionByLifecycleSettings) GetStatusOk() (*UserApplicationSubscriptionStatus, bool) {
	if o == nil || IsNil(o.Status) {
		return nil, false
	}
	return o.Status, true
}

// HasStatus returns a boolean if a field has been set.
func (o *UserSubscriptionByLifecycleSettings) HasStatus() bool {
	if o != nil && !IsNil(o.Status) {
		return true
	}

	return false
}

// SetStatus gets a reference to the given UserApplicationSubscriptionStatus and assigns it to the Status field.
func (o *UserSubscriptionByLifecycleSettings) SetStatus(v UserApplicationSubscriptionStatus) {
	o.Status = &v
}

// GetIsAdmin returns the IsAdmin field value if set, zero value otherwise.
func (o *UserSubscriptionByLifecycleSettings) GetIsAdmin() bool {
	if o == nil || IsNil(o.IsAdmin) {
		var ret bool
		return ret
	}
	return *o.IsAdmin
}

// GetIsAdminOk returns a tuple with the IsAdmin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *UserSubscriptionByLifecycleSettings) GetIsAdminOk() (*bool, bool) {
	if o == nil || IsNil(o.IsAdmin) {
		return nil, false
	}
	return o.IsAdmin, true
}

// HasIsAdmin returns a boolean if a field has been set.
func (o *UserSubscriptionByLifecycleSettings) HasIsAdmin() bool {
	if o != nil && !IsNil(o.IsAdmin) {
		return true
	}

	return false
}

// SetIsAdmin gets a reference to the given bool and assigns it to the IsAdmin field.
func (o *UserSubscriptionByLifecycleSettings) SetIsAdmin(v bool) {
	o.IsAdmin = &v
}

// GetJoinSelfSubscriptionGroupPendingRequestId returns the JoinSelfSubscriptionGroupPendingRequestId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *UserSubscriptionByLifecycleSettings) GetJoinSelfSubscriptionGroupPendingRequestId() string {
	if o == nil || IsNil(o.JoinSelfSubscriptionGroupPendingRequestId.Get()) {
		var ret string
		return ret
	}
	return *o.JoinSelfSubscriptionGroupPendingRequestId.Get()
}

// GetJoinSelfSubscriptionGroupPendingRequestIdOk returns a tuple with the JoinSelfSubscriptionGroupPendingRequestId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *UserSubscriptionByLifecycleSettings) GetJoinSelfSubscriptionGroupPendingRequestIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.JoinSelfSubscriptionGroupPendingRequestId.Get(), o.JoinSelfSubscriptionGroupPendingRequestId.IsSet()
}

// HasJoinSelfSubscriptionGroupPendingRequestId returns a boolean if a field has been set.
func (o *UserSubscriptionByLifecycleSettings) HasJoinSelfSubscriptionGroupPendingRequestId() bool {
	if o != nil && o.JoinSelfSubscriptionGroupPendingRequestId.IsSet() {
		return true
	}

	return false
}

// SetJoinSelfSubscriptionGroupPendingRequestId gets a reference to the given NullableString and assigns it to the JoinSelfSubscriptionGroupPendingRequestId field.
func (o *UserSubscriptionByLifecycleSettings) SetJoinSelfSubscriptionGroupPendingRequestId(v string) {
	o.JoinSelfSubscriptionGroupPendingRequestId.Set(&v)
}

// SetJoinSelfSubscriptionGroupPendingRequestIdNil sets the value for JoinSelfSubscriptionGroupPendingRequestId to be an explicit nil
func (o *UserSubscriptionByLifecycleSettings) SetJoinSelfSubscriptionGroupPendingRequestIdNil() {
	o.JoinSelfSubscriptionGroupPendingRequestId.Set(nil)
}

// UnsetJoinSelfSubscriptionGroupPendingRequestId ensures that no value is present for JoinSelfSubscriptionGroupPendingRequestId, not even an explicit nil
func (o *UserSubscriptionByLifecycleSettings) UnsetJoinSelfSubscriptionGroupPendingRequestId() {
	o.JoinSelfSubscriptionGroupPendingRequestId.Unset()
}

func (o UserSubscriptionByLifecycleSettings) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o UserSubscriptionByLifecycleSettings) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Application) {
		toSerialize["application"] = o.Application
	}
	if !IsNil(o.LifecycleSettings) {
		toSerialize["lifecycleSettings"] = o.LifecycleSettings
	}
	if !IsNil(o.Status) {
		toSerialize["status"] = o.Status
	}
	if !IsNil(o.IsAdmin) {
		toSerialize["isAdmin"] = o.IsAdmin
	}
	if o.JoinSelfSubscriptionGroupPendingRequestId.IsSet() {
		toSerialize["joinSelfSubscriptionGroupPendingRequestId"] = o.JoinSelfSubscriptionGroupPendingRequestId.Get()
	}
	return toSerialize, nil
}

type NullableUserSubscriptionByLifecycleSettings struct {
	value *UserSubscriptionByLifecycleSettings
	isSet bool
}

func (v NullableUserSubscriptionByLifecycleSettings) Get() *UserSubscriptionByLifecycleSettings {
	return v.value
}

func (v *NullableUserSubscriptionByLifecycleSettings) Set(val *UserSubscriptionByLifecycleSettings) {
	v.value = val
	v.isSet = true
}

func (v NullableUserSubscriptionByLifecycleSettings) IsSet() bool {
	return v.isSet
}

func (v *NullableUserSubscriptionByLifecycleSettings) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableUserSubscriptionByLifecycleSettings(val *UserSubscriptionByLifecycleSettings) *NullableUserSubscriptionByLifecycleSettings {
	return &NullableUserSubscriptionByLifecycleSettings{value: val, isSet: true}
}

func (v NullableUserSubscriptionByLifecycleSettings) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableUserSubscriptionByLifecycleSettings) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
